""" Addon Information """
# ------------
# EventScripts Script-Addon:    - Exact Bomb-Timer (EBT, ebt.py, 3.9kb)
# Author:                       - BackRaw - http://forums.eventscripts.com/profile.php?mode=viewprofile&u=13683
#                                           http://addons.eventscripts.com/addons/user/13683
# Version:                      - 1.0
# ------------

""" Imports """
# ------------
# EventScripts Core-Module      - ES functionality
import es
# Usermsg                       - Hud-Hint messages
from usermsg import hudhint
# Gamethread                    - Delayed functions
from gamethread import delayed
# ------------

""" Class - BombTimer """
# ------------
# This handles counting the exact bomb-time
# ------------
class BombTimer(object):
    def __init__(self):
        self.timer = 0.0
    def beginPlant(self):
        self.timer = 0.0
        self.countTimer('+')
    def countTimer(self, sign='-'):
        if sign == '-':
            if self.timer > 1:
                self.timer -= 1
                hudhint('#all', 'Exact Bomb-Timer: %s' % self.timer)
                es.centermsg('Exact Bomb-Timer: %s' % self.timer)
                delayed(1, self.countTimer)
            else:
                hudhint('#all', 'Bomb-Timer: Bomb Exploded!')
        else:
            if self.timer < 2.9:
                self.timer += .1
                delayed(.1, self.countTimer, '+')
            else:
                self.timer = es.getInt('mp_c4timer') + 1
                self.countTimer()
bt = BombTimer()

""" Events """
# ------------
# Call the beginPlant function in the class BombTimer
# ------------
def bomb_beginplant(ev):
    bt.beginPlant()

""" Client-Command Filter """
# ------------
# Allows non-rcon previleged players to check the current EBT-version
# ------------
def commandFilter(userid, args):
    if 'ebt' in args[0].lower():
        es.cexec(userid, 'echo ebt_ver = 1.0')
        es.cexec(userid, 'echo - notify replicated')
        es.cexec(userid, 'echo -- Exact BombTimer - Display the exact bomb-time to every player on the server.')
    return True

""" EventScripts main-control functions """
# ------------
# Set the current version on load
# Allow non-rcon previleged players to check the current EBT-version
# ------------
def load():
    es.ServerVar('ebt_ver', '1.0', 'Exact BombTimer - Displays the exact bomb-time to every player on the server.').makepublic()
    es.addons.registerClientCommandFilter(commandFilter)

def unload():
    es.addons.unregisterClientCommandFilter(commandFilter)

""" End Code """
